-------------------------- MODULE MSPastry ---------------------------
\* This is the specification of MSPastry
(* The hierarchy of the modules are
 Ring (The basic parameters and operations for ring calculation)
   \subset LS (The leaf set utilities)
      \subset RT (The routing table utilities)
         \subset Msg (The messages definitions)
            \subset InitialStates (The initial state and TypeInvariant)
               \subset Actions (All the actions)
                  \subset MSPastry (The specification of MSPastry including properties)
                     \subset MCMSPastry (The demonstration assignments for MSPastry)
*)
\* This version is based on the paper Castro04, Haeber06 
\* and the source codes from www.FreePastry.com
EXTENDS Actions
----------------------------------------------------------------------
\* here are all the global variables
vars == <<receivedMsgs, active, rtable, lset, probing, failed>>
\* here are all possible actions to be applied for next step
Next == \E i, j \in I:
      \/ RouteLookup(i, j) 
      \/ RouteJReq(i, j) 
      \/ CastroDeliver(i, j)
      \/ RecProbe(i)
      \/ RecPRply(i) 
      \/ CastroRecJReq(i)
      \/ RecJReply(i)
      \* followed are application (interface) actions:
      \/ NodeLeft(i)
      \/ CastroJoin(i, j)
      \/ SuspectFaulty(i, j)
      \/ TimeOut(i, j)
      \/ LSRepair(i)
Spec == \* The general specification of MSPastry
/\ Init 
/\ [][Next]_vars

==============================================================
